module tools
{
	let path, fs;
    let require = window["nodeRequire"];
    if (typeof require === "function") { //是Electron环境
        path = require("path");
        fs = require("fs");
    }

    export function readImageSync(url, bitmap: egret.Bitmap)
    {
        return new Promise((suc, failed)=>{
            if (fs){
                let byte = <egret.ByteArray>fs.readFileSync(url);
                if (byte && byte.buffer){
                    byte.position = 0;
                    console.log("has ", url);
                    egret.BitmapData.create("arraybuffer", byte.buffer, (bitmapData: egret.BitmapData)=>{
                        if (bitmapData && bitmap){
                            let tex = new egret.Texture();
                            tex.bitmapData = bitmapData;
                            bitmap.texture = tex;
                        }
                        console.log("load complete", url);
                        suc("ok");
                    })
                }
                else {
                    failed("readImageSync  byte 不存在");
                }
            }
            else {
                failed("readImageSync  fs 不存在")
            }
        })
    }
}