module junyou {
    
    export interface IRecyclable{
        onRecycle();
        onSpawn();
    }
    
	/**
	 * 回收池
	 * @author 3tion
	 *
	 */
    export class RecyclablePool<T extends IRecyclable> {
    	
        private _pool: T[];
        private _max: number;
        private _TCreator:{ new(): T };
    	
        public getInstance():T{
            var ins: T;
            var pool = this._pool;
            if(pool.length){
                ins = pool.pop();
            }else{
                ins = new this._TCreator();
            }
            ins.onSpawn();
            return ins;
        }
        
        /**
         * 回收
         */ 
        public recycle(t:T){
            t.onRecycle();
            let pool = this._pool;
            if(pool.length<this._max){
                if(!~pool.indexOf(t)){
                    pool.push(t);
                }
            }
        }
        
        public constructor(TCreator: { new (): T },max = 100) {
            this._pool = [];
            this._max = max;
            this._TCreator = TCreator;
		}
	}
}
