module junyou {
	/**
	 * 配置加载器
	 * @author 3tion
	 *
	 */
	export class DataLocator {

        parsers:{[index:string]:ConfigDataParser};
        
        public data: { [index: string]: any };
        
		public constructor() {
            this.parsers = {};
            this.data = {};
		}
		
		
        /**
         * 注册配置解析
         * @param key       配置的标识
         * @param parser    解析器
         */
        public regParser(key: string,parser: ConfigDataParser){
            this.parsers[key]=parser;
        }
		
        
		/**
		 * 解析所有数据
		 */
		public parseDatas(){
            var parsers = this.parsers;
            for(let key in parsers){
                let parser = parsers[key];
                this.data[key]=parser(RES.getRes(key));
                RES.destroyRes(key);
            }
		}
		
        static instance: DataLocator = new DataLocator();
        
        
        /**
         * 根据标识获取配置数据
         * @param key   标识
         */
        static getData(key:string):any{
            return DataLocator.instance.data[key];
        }
	}
	
	/**
	 * 配置数据解析函数
	 */ 
    export interface ConfigDataParser{
        (data: any): any;
    }
}
