module junyou.game {

	/**
	 * 动作数据
	 */
    export class ActionInfo {
        /**
         * 动作的标识
         */
        public key: number;
        
        /**
         * 帧信息列表
         */
        public frames: FrameInfo[];
        
        /**
         * 总帧数
         */
        public totalFrame: number;
        
        /**
         * 动画默认的总时间
         */
        public totalTime: number;
        
        /**
         * 是否为循环动作
         */
        public isCircle: boolean;

        static fromData(data,key:any) {                    
            //        toData() {
            //            return [this.key,this.data.toData()];
            //        }
            var aInfo = new ActionInfo();
            aInfo.key = key;
            var d: any[] = data[0];            
            var totalTime: number = 0;
            d.forEach((item,idx,arr) => {
                let f = FrameInfo.fromData(item);
                totalTime += f.t;
                arr[idx] = f;
            });
            aInfo.frames = d;
            aInfo.totalFrame = d.length;
            aInfo.totalTime = totalTime;
            aInfo.isCircle = !!data[1];
            return aInfo;
        }
    }
}
