module junyou.game {
    import Event = egret.Event;
	/**
	 * 由于目前特效和渲染器是完全一一对应关系，所以直接做成AniBitmap
	 * @author 3tion
	 *
	 */
    export class AniRender extends BaseRender implements IRecyclable{

        protected _guid:number;

        /**
         * 特效标识
         */
        public get guid(): number {
            return this._guid;
        }

        /**
         * 显示对象
         */
        public display:ResourceBitmap;

        public _aniInfo: AniInfo;

		public constructor() {
    		super();
    		// ani动画的动作固定值0
    		this.a = 0;
		}

		protected render(e:Event){
		    var aniInfo = this._aniInfo;
            var actionInfo = aniInfo.actionInfo;
            if(actionInfo){
                this.doRender(actionInfo);
            }
		}
		renderFrameIndex(index: number) {
            let aniInfo = this._aniInfo;
            let actionInfo = aniInfo.actionInfo;
            let frames = actionInfo.frames;
            if (index < frames.length) {
                this.renderFrame(frames[index], Date.now());
            }
        }
        renderFrame(frame: FrameInfo,now: number) {
            this.f = frame.f;
            this.display.draw(this,now);
        }

		public play(){
            this.display.addEventListener(Event.ENTER_FRAME,this.render,this);
		}

		public pause(){
            this.display.removeEventListener(Event.ENTER_FRAME,this.render,this);
		}

        public onRecycle(){
            this.display.removeEventListener(Event.ENTER_FRAME,this.render,this);
            this._aniInfo = null;
            this._guid = NaN;
        }

        public onSpawn(){
            this.f = 0;
            this._playSpeed = 1;
        }

        private static guid = 1;

        private static _pool:RecyclablePool<AniRender>=new RecyclablePool(AniRender);

		public static getAni(uri:string,display:ResourceBitmap = null){
            var aniInfo: AniInfo = DataLocator.getData(ConfigKey.ANI)[uri];
            if(aniInfo){
                display = display || ResourceBitmap.getInstance();
                let ani = this._pool.getInstance();
                ani._aniInfo = aniInfo;
                ani.display = display;
                display.res = aniInfo.getResource();
                ani._guid = this.guid++;
                return ani;
            }
            ThrowError("无法找到指定特效的配置:"+uri);
            return null;
		}
	}
}
