module junyou.game {
	/**
	 *
	 * @author 
	 *
	 */
    export class BaseRender implements IDrawInfo{
        

    	/**
    	 * 全局单位播放速度
    	 */
        public static globalPlaySpeed: number = 1;
        
        /**原始动作索引 */
        public a: number;
        /**原始方向索引 */
        public d: number = 0;
        /**原始帧数索引 */
        public f: number = 0;
        
        /**
         * 数组的索引
         */
        protected idx: number = 0;

        /**
         * 下一次需要重新计算渲染的时间
         */
        protected nextRenderTime: number = 0;

        
        /**
         * 当前渲染时间
         */
        protected renderedTime: number = 0;
        
        /**
         * 播放速度，默认为1倍速度<br/>
         * 值越高，速度越快
         */
        protected _playSpeed: number = 1;
        
        /**
         * 播放速度，默认为1倍速度<br/>
         * 值越高，速度越快
         */
        public get playSpeed(): number {
            return this._playSpeed;
        }
        
        /**
         * 设置播放速度
         */
        public set playSpeed(value: number) {
            if(value < 0) {
                value = 0;
            }
            if(value != this._playSpeed) {
                this._playSpeed = value;
            }
        }
        
        protected doRender(actionInfo:ActionInfo){
            // var now: number = Date.now();
            // var nextRenderTime = this.nextRenderTime;
            
            // if(nextRenderTime < now) {
            //     if(now > nextRenderTime + 2000) {//说明手机/浏览器进入过待机状态，直接抛弃之前的过程
            //         this.nextRenderTime = now;
            //         this.renderedTime = now;
            //     }
            //     var renderedTime = this.renderedTime;
            //     this.clearRes();
                
            //     let frames: FrameInfo[] = actionInfo.frames;
            //     //当前帧
            //     let idx = this.idx;
    
            //     let flen = frames.length-1;
            //     let ps = this.playSpeed * BaseRender.globalPlaySpeed;
            //     let frame: FrameInfo;
            //     if(ps > 0) {
            //         ps = 1 / ps;
            //         if(ps < 0.01) {//最快处理100倍速度
            //             ps = 0.01;
            //         }
            //         do {
            //             frame = frames[idx];
            //             if(frame){
            //                 let tt = frame.t * ps || 0;
            //                 nextRenderTime = renderedTime + tt;
            //                 if(nextRenderTime < now) {
            //                     if(frame.e) {
            //                         this.dispatchEvent(frame.e,now);
            //                     }
            //                     renderedTime = nextRenderTime;
            //                     idx++;
            //                 }
            //                 else {
            //                     break;
            //                 }
            //             }else{
            //                 break;
            //             }
            //         }
            //         while(idx <= flen)
            //     }
            //     else {// 播放速度为0则暂停
            //         frame = frames[idx];
            //     }
            //     this.idx = idx;            
            //     this.renderedTime = renderedTime;
            //     this.nextRenderTime = nextRenderTime;
            //     this.renderFrame(frame,now);
    
            //     if(idx == flen) {
            //         this.idx = 0;
            //         if(!actionInfo.isCircle) {
            //             this.doComplete(now);
            //         }
            //     }
            // }
            let self = this;
            let now: number = Date.now();
            let nextRenderTime = self.nextRenderTime;
            if (nextRenderTime < now) {
                self.clearRes();
                var renderedTime = self.renderedTime;
                if (now - nextRenderTime > 200) {
                    nextRenderTime = now;
                    renderedTime = now;
                }
                let frames = actionInfo.frames;
                let idx = self.idx;//当前帧
                let flen = frames.length - 1;//最后一帧
                let ps = self.playSpeed * BaseRender.globalPlaySpeed;
                let frame = frames[idx];

                if (ps > 0) {
                    ps = Math.max(1 / ps, 0.01);
                    if (frame) {
                        let tt = frame.t * ps || now - renderedTime;// 容错
                        nextRenderTime = renderedTime + tt;
                        if (nextRenderTime < now) 
                            renderedTime = nextRenderTime;
                        else idx++;
                    }
                }

                self.idx = idx;
                self.renderedTime = renderedTime;
                self.nextRenderTime = nextRenderTime;
                self.renderFrame(frame,now);
                 if(idx > flen) {
                    this.idx = 0;
                    if(!actionInfo.isCircle) {
                        this.doComplete(now);
                    }
                }
            }
        }
        
        
        /**
         * 渲染指定帧
         * @param frame
         * @param now
         */
        protected renderFrame(frame: FrameInfo,now: number){
            this.f = frame.f;
        }
        
        
        /**
         * 清理当前帧
         */
        protected clearRes(){
            
        }
        
        
        /**
         * 派发事件
         * @param event     事件名
         * @param now       当前时间
         */
        protected dispatchEvent(event:string,now:number){
            
        }
        
        /**
         * 渲染结束
         * @param now       当前时间
         */
        protected doComplete(now:number){
            
        }
        
		public constructor() {
		}
	}
}
