module junyou.game {
    
	/**
	 * 使用JSON字符串的协议基类
	 * @author 
	 *
	 */
	export class SMessage implements IMessage {

        protected keys:string[];
    	
		public constructor() {
		}
		
		public toData(){
		    
		}
		
        /**
        * 从字节流中读取
        */
        public readFrom(bytes: ByteArray,len?: number): void {
            var json = bytes.readUTFBytes(len);
            var array = JSON.parse(json);
            var keys = this.keys;
            for(let i = 0,len = keys.length;i<len;i++){
                this[keys[i]]=array[i];
            }
        }

        /**
         * 写入字节流
         */
        public writeTo(bytes: ByteArray): ByteArray {
            var keys = this.keys;
            var array = [];
            for(let i = 0,len = keys.length;i < len;i++) {
                array[i] = this[keys[i]];
            }
            bytes.writeUTFBytes(JSON.stringify(array));
            if(DEBUG){
                if(bytes.length>65535){
                    ThrowError("指令为{0}消息过长，超过Short上限，请调整".substitute(egret.getQualifiedClassName(this)));
                }
            }
            return bytes;
        }
	}
}
